<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>

  <!-- ==================================================================== -->
	<xsl:template match="/">
	  <xsl:for-each select="//Element/Name">
	    <!-- <xsl:variable name="this" select="current()/@value"/> -->
  	  <xsl:if test="count(current()/preceding::Name[parent::Element and @value=current()/@value] | current()/ancestor::Name[parent::Element and @value=current()/@value])>0">
        <xsl:message terminate="yes">ERROR: There are two elements with the same name in the global constraint definition file. This is not allowed.</xsl:message> 	
  	  </xsl:if>
    </xsl:for-each>
	  <xsl:text disable-output-escaping="yes">
&lt;xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fm="http://www.pnp-software.com/XFeature/fmm"&gt;
  &lt;xsl:output method="text" version="1.0" encoding="UTF-8" indent="yes"/&gt; 	
    &lt;xsl:template match="/"&gt;
    </xsl:text>
 Application Constraint Checker will check global composition constraints
      <xsl:apply-templates select="//Element"/>
  		<xsl:apply-templates select="//GlobalConstraints/RequiresConstraint"/>
  		<xsl:apply-templates select="//GlobalConstraints/ExcludesConstraint"/>
  		<xsl:apply-templates select="//GlobalConstraints/CustomConstraint"/>
  		<xsl:apply-templates select="//GlobalConstraints/ConditionalConstraint"/>
    <xsl:text disable-output-escaping="yes">    
  &lt;/xsl:template&gt;
&lt;/xsl:stylesheet&gt;
    </xsl:text>
  </xsl:template>
  <!-- ==================================================================== -->


  <!-- ==================================================================== -->
  <xsl:template match="RequiresConstraint">
  Checking the requires constraint "<xsl:value-of select="Name/@value"/>" ...
    <xsl:text disable-output-escaping="yes">&lt;xsl:choose&gt;&lt;xsl:when test="not(count(</xsl:text><xsl:apply-templates select="Feature"/><xsl:text disable-output-escaping="yes">)&gt;0)or(</xsl:text><xsl:apply-templates select="RequiredFeature" mode="required"/><xsl:text disable-output-escaping="yes">(true()))"&gt;</xsl:text>              Constraint check "<xsl:value-of select="Name/@value"/>" passed.<xsl:text disable-output-escaping="yes">
      &lt;/xsl:when&gt;
      &lt;xsl:otherwise&gt;
        &lt;xsl:message terminate="yes"&gt;</xsl:text>Costraint check "<xsl:value-of select="Name/@value"/>" failed!<xsl:text disable-output-escaping="yes">&lt;/xsl:message&gt;
  		&lt;/xsl:otherwise>  
		&lt;/xsl:choose&gt;
    </xsl:text>
  </xsl:template>
  <!-- ==================================================================== -->


  <!-- ==================================================================== -->
  <xsl:template match="ExcludesConstraint">
  Checking the excludes constraint "<xsl:value-of select="Name/@value"/>" ...
    <xsl:text disable-output-escaping="yes">&lt;</xsl:text>xsl:variable name="SUM" select="(<xsl:apply-templates select="Feature" mode="sum"/>0)"<xsl:text disable-output-escaping="yes">/&gt;&lt;xsl:choose&gt;&lt;xsl:when test="</xsl:text><xsl:apply-templates select="Feature" mode="check"/><xsl:text disable-output-escaping="yes">(false())"&gt;</xsl:text>              Constraint check "<xsl:value-of select="Name/@value"/>" passed.<xsl:text disable-output-escaping="yes">
      &lt;/xsl:when&gt;
      &lt;xsl:otherwise&gt;
        &lt;xsl:message terminate="yes"&gt;</xsl:text>Costraint check "<xsl:value-of select="Name/@value"/>" failed!<xsl:text disable-output-escaping="yes">&lt;/xsl:message&gt;
  		&lt;/xsl:otherwise>  
		&lt;/xsl:choose&gt;
    </xsl:text>
  </xsl:template>
  <!-- ==================================================================== -->


  <!-- ==================================================================== -->
  <xsl:template match="CustomConstraint">
  Checking the custom constraint "<xsl:value-of select="Name/@value"/>" ...
    <!-- <xsl:apply-templates select="//Element"/> --><xsl:text disable-output-escaping="yes">&lt;xsl:choose&gt;&lt;xsl:when test="(</xsl:text><xsl:apply-templates select="CustomCondition"/><xsl:text disable-output-escaping="yes">)"&gt;</xsl:text>            Constraint check "<xsl:value-of select="Name/@value"/>" passed.<xsl:text disable-output-escaping="yes">
      &lt;/xsl:when&gt;
      &lt;xsl:otherwise&gt;
        &lt;xsl:message terminate="yes"&gt;Costraint check "</xsl:text><xsl:value-of select="Name/@value"/><xsl:text disable-output-escaping="yes">" failed!&lt;/xsl:message&gt;
  		&lt;/xsl:otherwise>  
		&lt;/xsl:choose&gt;
    </xsl:text>
  </xsl:template>
  <!-- ==================================================================== -->


  <!-- ==================================================================== -->
  <xsl:template match="ConditionalConstraint">
  Checking the custom conditional constraint "<xsl:value-of select="Name/@value"/>" ...
    <!-- <xsl:apply-templates select="//Element"/> --><xsl:text disable-output-escaping="yes">&lt;xsl:choose&gt;&lt;xsl:when test="(not(</xsl:text><xsl:value-of select="PreCondition/@value"/><xsl:text disable-output-escaping="yes">)or(</xsl:text><xsl:value-of select="PostCondition/@value"/><xsl:text disable-output-escaping="yes">))"&gt;</xsl:text>                        Constraint check "<xsl:value-of select="Name/@value"/>" passed.<xsl:text disable-output-escaping="yes">
      &lt;/xsl:when&gt;
      &lt;xsl:otherwise&gt;
        &lt;xsl:message terminate="yes"&gt;Costraint check "</xsl:text><xsl:value-of select="Name/@value"/><xsl:text disable-output-escaping="yes">" failed!&lt;/xsl:message&gt;
  		&lt;/xsl:otherwise>  
		&lt;/xsl:choose&gt;
    </xsl:text>
  </xsl:template>
  <!-- ==================================================================== -->
  
  
  <!-- ==================================================================== -->
<!--
  <xsl:template match="CustomConstraint/Name">
    <xsl:value-of select="@value"/>
  </xsl:template>
-->  
  <!-- ==================================================================== -->

  
  <!-- ==================================================================== -->
  <xsl:template match="Element">
<xsl:text disable-output-escaping="yes">&#xA;    &lt;</xsl:text>xsl:variable name="<xsl:apply-templates select="Name"/>" select="<xsl:apply-templates select="Value"/>"<xsl:text disable-output-escaping="yes">/&gt;</xsl:text>
  </xsl:template>
  <!-- ==================================================================== -->


  <!-- ==================================================================== -->
  <xsl:template match="Name">
    <xsl:value-of select="@value"/>
  </xsl:template>
  <!-- ==================================================================== -->


  <!-- ==================================================================== -->
  <xsl:template match="Value">
    <xsl:value-of select="./@value"/>
  </xsl:template>
  <!-- ==================================================================== -->


  <!-- ==================================================================== -->
  <xsl:template match="CustomCondition">
    <xsl:value-of select="@value"/>
  </xsl:template>
  <!-- ==================================================================== -->


  <!-- ==================================================================== -->
  <xsl:template match="RequiresConstraint/Feature">
    <xsl:value-of select="@value"/>
  </xsl:template>
  <!-- ==================================================================== -->


  <!-- ==================================================================== -->
  <xsl:template match="RequiresConstraint/RequiredFeature" mode="required">
    (count(<xsl:value-of select="@value"/>)>0)and
  </xsl:template>
  <!-- ==================================================================== -->


  <!-- ==================================================================== -->
  <xsl:template match="ExcludesConstraint/Feature" mode="sum">
    count(<xsl:value-of select="@value"/>)+
  </xsl:template>
  <!-- ==================================================================== -->


  <!-- ==================================================================== -->
  <xsl:template match="ExcludesConstraint/Feature" mode="check">
    ($SUM=count(<xsl:value-of select="@value"/>))or
  </xsl:template>
  <!-- ==================================================================== -->

  
</xsl:stylesheet>
